﻿Type=Service
Version=2.51
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: False
#End Region

Sub Process_Globals
	Private server As HttpServer
	Private templates As Map
	Private su As StringUtils
	Public port As Int = 6666
	Private Messages As List
End Sub
Sub Service_Create
	server.Initialize("Server")
	server.Start(port)
	templates.Initialize
	Dim n As Notification
	n.Initialize
	n.Icon = "icon"
	n.SetInfo("Http Server is running", "", Main)
	Service.StartForeground(1, n)
	Messages.Initialize
End Sub

Sub Service_Start (StartingIntent As Intent)
	
End Sub

Sub Server_HandleRequest (Request As ServletRequest, Response As ServletResponse)
	Try
		Log("Client: " & Request.RemoteAddress & ", Request: " & Request.RequestURI)
		If Request.Method = "POST" Then 'User pressed on the Send button
			Messages.Add("<b>" & Request.GetParameter("username") & "</b>: " & Request.GetParameter("message") & "<br/>")
			Response.SendRedirect("/?username=" & su.EncodeUrl(Request.GetParameter("username"), "UTF8"))
			If Messages.Size > 10 Then Messages.RemoveAt(0)
		Else If Request.RequestURI.StartsWith("/chat") Then 'AJAX query to get the chat every 5 seconds
			Response.SendString(ConvertMessagesToString)
		Else 'regular call
			Dim MainPage As String = GetTemplate("template.html")
			Dim userName As String = Request.GetParameter("username")
			MainPage = MainPage.Replace("$NAME$", userName)
			MainPage = MainPage.Replace("$CHAT$", ConvertMessagesToString)
			Response.SetContentType("text/html")
			Response.SendString(MainPage)
		End If
	Catch
		Response.Status = 500
		Log("Error serving request: " & LastException)
		Response.SendString("Error serving request: " & LastException)
	End Try
End Sub

Sub ConvertMessagesToString As String
	Dim sb As StringBuilder
	sb.Initialize
	For Each s As String In Messages
		sb.Append(s)
	Next
	Return sb.ToString
End Sub
Sub GetTemplate(Name As String) As String
	If templates.ContainsKey(Name) Then Return templates.Get(Name)
	Dim temp As String = File.ReadString(File.DirAssets, Name)
	templates.Put(Name, temp)
	Return temp
End Sub

Sub Service_Destroy
	server.Stop
	Service.StopForeground(1)
End Sub
